#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

int rappresentante(int find, int *find_vect) {
    if(find_vect[find] != find)
        find_vect[find] = rappresentante(find_vect[find],find_vect);

    return find_vect[find];
}

int main() {

    // definisco i grafi graph_orig e graphMST
    vector< pair<int, pair<int,int> > > graph_orig,graphMST;

    int tot_nodi,tot_archi;

    // carico i primi due valori rappresentanti rispettivamente il numero di nodi (n) e il numero di archi (e)
    ifstream f("input.txt");
    f>>tot_nodi>>tot_archi;

    int find_vect[tot_nodi];

    // inizializzo la variabile 
    for(int i=1; i<=tot_nodi; i++)
        find_vect[i] = i;

    // carico i successivi valori che rappresentano i due nodi collegati e il peso dell'arco
    int u,v,p;
    for(int i=0; i<tot_archi; i++) {
        f>>u>>v>>p;
        graph_orig.push_back(pair<int, pair<int,int> >(p,make_pair(u,v)));
    }

    // ordinamento del grafo in base ai pesi dal peso minore al peso maggiore
    sort(graph_orig.begin(),graph_orig.end());

    // popolo il grafo graphMST solo con i nodi
    int somma = 0;
    for(int i=0; i<tot_archi; i++) {
        int find_u = rappresentante(graph_orig[i].second.first,find_vect);
        int find_v = rappresentante(graph_orig[i].second.second,find_vect);
        if(find_u!=find_v) {
            graphMST.push_back(graph_orig[i]);
            // cambio il rappresentante
            find_vect[find_u] = find_vect[find_v];
            somma+=graph_orig[i].first;
        }
    }

    ofstream sout("output.txt");

    sout << somma << "\n";
    
    for (int i=0; i<graphMST.size();i++)
        (graphMST[i].second.first < graphMST[i].second.second) ? (sout << graphMST[i].second.first << " " << graphMST[i].second.second << endl) : (sout << graphMST[i].second.second << " " << graphMST[i].second.first << endl);
    
}
